unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  comobj,  ExtCtrls, StdCtrls, Menus, Buttons, ToolWin, ComCtrls, Spin,
  Grids, modbus;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    menu_comm: TMenuItem;
    menu_Open: TMenuItem;
    Menu_close: TMenuItem;
    N1: TMenuItem;
    menu_Settings: TMenuItem;
    Datas: TMemo;
    Timer: TTimer;
    gr_Data: TGroupBox;
    Label1: TLabel;
    data_quantity: TSpinEdit;
    data_type: TComboBox;
    Label2: TLabel;
    Gr_device: TGroupBox;
    Label3: TLabel;
    device_number: TSpinEdit;
    Label4: TLabel;
    About1: TMenuItem;
    HintBar: TStatusBar;
    Bevel1: TBevel;
    port_number: TComboBox;
    data_address: TEdit;
    GroupBox1: TGroupBox;
    Status: TMemo;
    Status_Menu: TPopupMenu;
    Clear: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure readdata;
    procedure data_addressKeyPress(Sender: TObject; var Key: Char);
    procedure menu_OpenClick(Sender: TObject);
    procedure Menu_closeClick(Sender: TObject);
    procedure OnError(Sender:TObject;Err:Exception);
    procedure ClearClick(Sender: TObject);
    procedure showhint(Sender:TObject);
    procedure menu_SettingsClick(Sender: TObject);
    procedure About1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;
var
  Form1: TForm1;
  mbserver:variant;
  data:variant;

  parity,
  FlowControl,
  TransmissionMode,
  StopBits,
  ByteSize:byte;

  baudrate,
  TimeOut,
  SilentInterval:integer;

implementation



uses settings, About;

{$R *.DFM}

procedure Tform1.Showhint(Sender:TObject);
begin
//   Display hints on statusbar
     Hintbar.SimpleText:=Application.hint;
end;

procedure Tform1.OnError(Sender:TObject;Err:Exception);
begin
// If any errors detected this code procedure is executed
// On any communication error occured Close com port which has
//    been opened and display an error message
     beep;
     Status.Lines.add(err.Message+', Closing com'+
        inttostr(mbserver.comport)+
     '. Reading Data Aborted, check your settings!');
     Menu_close.Click;
end;
procedure tform1.readdata;
var
   device,
   address,
   quantity,
   i:integer;
   text:string;
begin
     Datas.Lines.clear;
     address:=strtointdef(data_address.Text,0);
     quantity:=data_quantity.value;
     device:=device_number.Value;
     data:= VarArrayCreate([0,quantity-1], varvariant);

{ I used just readoutputregisters and ReadOutputStatus functions
  you can use ReadInputStatus and ReadInputRegisters if you wish}

   case data_type.ItemIndex of
     0:
     begin
{Read register as integer.
To read as other data types varinteger constant should be replaced with constants
defined in system unit}
    mbserver.ReadOutputRegisters(device,address,quantity,data,varinteger);
      for i:=0 to quantity-1 do
      begin
        text:=string(data[i]);
        datas.lines.Add('['+inttostr(address+i)+'] = '+text);
      end;
     end; {end of readoutputregisters}
     1:
     begin
     {read register; false = (data=0), true = (data=-1)   ???}
      mbserver.ReadOutputStatus(device,address,quantity,data);
      for i:=0 to quantity-1 do
          begin
          text:='True';
           if not data[i] then text:='False';
           datas.lines.Add('['+inttostr(address+i)+'] = '+text);
          end;
     end; {end of ReadOutputStatus}
   end; {end of case statement}
end;


procedure TForm1.FormCreate(Sender: TObject);
begin
// initialize port settings this variables are also used/changed by
//   settings form
     baudrate:=9600;
     parity:=mbNOPARITY;
     FlowControl := mbFC_NONE;
     TimeOut := 1000;     // Response of device = 1000 ms
     TransmissionMode := mbMODE_RTU;   // Use transmission mode RTU
     SilentInterval := 20;  // RTU messages start and end with a silent
                            // interval of at least 3.5 character times.
                            // For instance , for baud rate of 9600 bps
                            // silent interval is 4 ms , but when doing
                            // some practical tests this value was increased
                            // to 20 ms for correct communication with devices,
                            // try to increase this value if you get many
                            // communication errors. When using ASCII set
                            // silent interval 500 or 1000 ms.

     ByteSize := 8;             // RTU uses 8 bits, ASCII uses 7 bits
     StopBits := mbTWOSTOPBITS; // Use 2 stop bits if noparity and
                                // 1 stop bits if parity used otherwise

     application.OnHint:=Showhint;         // Display hints
     Application.OnException:=OnError;     // Handle Exceptions
     data_type.ItemIndex:=0;               // Initial Data type is Integer
     port_number.ItemIndex:=0;             // Initial port is Com1
     datas.Lines.clear;
     mbserver:=Createoleobject('ModbusSrv.ModbusSrv.1'); // Create server
                                                         // as ole object
end;

procedure TForm1.TimerTimer(Sender: TObject);
begin
     readdata;                      // get registers
end;

procedure TForm1.data_addressKeyPress(Sender: TObject; var Key: Char);
begin
     if data_address.text='' then data_address.text:='0';
end;

procedure TForm1.menu_OpenClick(Sender: TObject);
begin
        mbserver.openconnection('Serial',mblocal);  // open serial connection
        mbserver.comport:=port_number.ItemIndex+1;
        mbserver.baudrate:=baudrate;
        mbserver.parity:=parity;
        mbserver.FlowControl := FlowControl ;
        mbserver.SilentInterval := SilentInterval ;
        mbserver.TimeOut := TimeOut ;
        mbserver.TransmissionMode := TransmissionMode ;
        mbserver.ByteSize := ByteSize;
        mbserver.StopBits := StopBits ;

        mbserver.raiseerror:=true;  // Let server raise errors, so we can handle
        // mbserver.connect = true expression is not true since return value
        // is -1 while true and 0 while result is 0
        // Everything seems clear in fi-then-else statement
     if (mbserver.connect=true_bool)  // if connected to serial device
   then
       begin
          menu_Open.Enabled:=false;
          Menu_close.enabled:=true;
          menu_Settings.enabled:=false;
          port_number.enabled:=false;
          status.Lines.Add('Com'+inttostr(mbserver.comport)+ ' port opened.');
          timer.enabled:=true;
       end
   else
       begin
          beep;
          status.Lines.Add('Com'+inttostr(mbserver.comport)+ ' could not opened, '+
          'check your port settings');
       end;

end;

procedure TForm1.Menu_closeClick(Sender: TObject);
begin
     // Write that Com port is closed
     status.Lines.Add('Com'+inttostr(mbserver.comport)+ ' port closed.');
     // this code should be executed before mbserver.closeconnection
     // procedure!

     //   And other expressions.
     mbserver.closeconnection;
     timer.enabled:=false;
     datas.lines.clear;
     menu_Open.enabled:=true;
     menu_close.enabled:=false;
     menu_Settings.enabled:=true;;
     port_number.enabled:=true;
end;

procedure TForm1.ClearClick(Sender: TObject);
begin
     Status.Lines.clear;
end;

procedure TForm1.menu_SettingsClick(Sender: TObject);
begin
// Show Setting Form as modal.
     form2.ShowModal;
end;

procedure TForm1.About1Click(Sender: TObject);
begin
     Form3.ShowModal;
end;

end.
